ImportC "zx2gif.lib"
  Dogif(s.s,hwnd.l) As "_ConvertGIF"
EndImport

Global xres=256*2
Global yres=192*2
Global *filemem
Global zoo
Global act
Global File$
Global saveflag

Procedure drawzx()
  
  act=GetGadgetState(2)
  zoo=GetGadgetState(3)+1;1=x1,2=x2
  
  FreeImage(4)
  CreateImage(4, 256*zoo, 192*zoo,24)
  
  StartDrawing(ImageOutput(4))
  Box(0,0,256*zoo, 192*zoo,0)
  
  For t=0 To 2  
    For k=0 To 7
      For i=0 To 255
        zxatr.a=PeekA(*filemem+i+t*256+6144)
        aa.a=PeekA(*filemem+i+k*256+t*2048)
        
        If GetGadgetState(4);act=1
          zxatr=7
        EndIf
        
        bw.a=128
        For j=0 To 7
          
          If Not aa&bw;Mid(bb.s,j+1,1)="0"
            papi=(zxatr>>3)&7
            colwei=192
            
            If zxatr&64
              colwei=255
            EndIf
            
            papr.a=((papi>>1)&1)*colwei
            papb.a=(papi&1)*colwei
            papg.a=((papi>>2)&1)*colwei
            colr=RGB(papr,papg,papb)
          Else
            inki=zxatr&7
            colwei=192
            If zxatr&64
              colwei=255
            EndIf
            
            inkr.a=((inki>>1)&1)*colwei
            inkb.a=(inki&1)*colwei
            inkg.a=((inki>>2)&1)*colwei
            colr=RGB(inkr,inkg,inkb)
          EndIf
          
          y=Int(i/32)*8+k+t*64
          x=(i%32)*8+j
          Box(x*zoo,y*zoo,zoo,zoo,colr)
          
          bw=bw>>1
        Next j
      Next i
    Next k
  Next t
  
  StopDrawing()
  If act<=1
    SetGadgetState(0,ImageID(4))
  EndIf
EndProcedure

Procedure check_combbo()
  drawzx()
  Select GetGadgetState(2)
    Case 1:
      CreateFile(1,File$+".screen")
      WriteData(1,*filemem,6144)
      CloseFile(1)
      CreateFile(1,File$+".attr")
      WriteData(1,*filemem+6144,768)
      CloseFile(1)
    Case 2:
      If saveflag
        SaveImage(4, File$+".jpg", #PB_ImagePlugin_JPEG)
      EndIf
    Case 3:
      If saveflag
        SaveImage(4, File$+".bmp", #PB_ImagePlugin_BMP)
      EndIf
    Case 4:
      If saveflag
        SaveImage(4, File$+".png", #PB_ImagePlugin_PNG)
      EndIf
    Case 5:
      If saveflag
        If GetGadgetState(3)+1=1
          Dogif (File$+".scr",0)
        Else
          MessageRequester("Warning!","works only for x1!")
        EndIf
      EndIf
  EndSelect
EndProcedure

OpenWindow(0, 0, 0, xres, 20+yres, "ZXscr2Pic 2", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)

UseJPEGImageEncoder()
UsePNGImageEncoder()

CreateImage(4, 256, 192,24,0)

ImageGadget(0, 128, 96, xres/2, yres/2, ImageID(4))

EnableGadgetDrop(0, #PB_Drop_Files,#PB_Drag_Copy)
;TextGadget(1,0,0,40,20,"Action:")
ComboBoxGadget(2,00,0,120,20)
AddGadgetItem(2, -1, "Preview")
;AddGadgetItem(2, -1, "Preview no colour")
AddGadgetItem(2, -1, "Split screen&attr")
AddGadgetItem(2, -1, "Save .JPEG file")
AddGadgetItem(2, -1, "Save .BMP file")
AddGadgetItem(2, -1, "Save .PNG file")
AddGadgetItem(2, -1, "Save .GIF file")
SetGadgetState(2,0)
GadgetToolTip(2,"choose action")

ComboBoxGadget(3,120,0,120,20)
AddGadgetItem(3, -1, "x1")
AddGadgetItem(3, -1, "x2")
SetGadgetState(3,0);1
GadgetToolTip(3,"zoom x2")

CheckBoxGadget(4,240,0,120,20,"b/w")
GadgetToolTip(4,"color or black-white")

*filemem=AllocateMemory(6912)
saveflag=0
;   Debug GetGadgetState(2)

If CountProgramParameters()
  f.s=ProgramParameter(0)
  If FileSize(f)=6912
    If ReadFile(0,f)
      ReadData(0,*filemem,6912)
      CloseFile(0)
      SetWindowTitle( 0,"ZXscr2Pic 2 : "+GetFilePart(f) )
      drawzx()
      SetGadgetState(0,ImageID(4))
      
      File$=f
      If LCase(Mid(File$,Len(File$)-3))=".scr"
        File$=Mid(File$,1,Len(File$)-4)
      EndIf
      saveflag=1
    Else
      MessageRequester("Error!","can't read:"+f)
    EndIf
  Else
    MessageRequester("Error!","Wrong size for:"+f)
  EndIf
EndIf

Repeat
  Event = WaitWindowEvent()
  
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    Break;Exit = #True
  EndIf
  
  Select Event
    Case #PB_Event_Gadget
      Select EventGadget()
        Case 3:
          ;Debug GetGadgetState(3)
          If GetGadgetState(3)=0
            ResizeGadget(0,128,96,256,192)
            drawzx()
            SetGadgetState(0,ImageID(4))
          Else
            ResizeGadget(0,0,20,512,384)
            drawzx()
            SetGadgetState(0,ImageID(4))
          EndIf
          drawzx()
        Case 4:
          drawzx()
        Case 2:
          check_combbo()
      EndSelect
      
    Case #PB_Event_GadgetDrop
      Files$ = EventDropFiles()
      
      Count  = CountString(Files$, Chr(10)) + 1
      saveflag=1
      For ii = 1 To Count
        File$ = StringField(Files$, ii, Chr(10))
        
        If FileSize(File$)=6912
          act=GetGadgetState(2)
          zoo=GetGadgetState(3)+1;1=x1,2=x2
          ReadFile(0,File$)
          ReadData(0,*filemem,6912)
          CloseFile(0)
          SetWindowTitle( 0,"ZXscr2Pic 2 : "+GetFilePart(File$) )
          
          If LCase(Mid(File$,Len(File$)-3))=".scr"
            File$=Mid(File$,1,Len(File$)-4)
          EndIf
          
          check_combbo()
        Else
          MessageRequester("Error!","Wrong size for:"+File$)
        EndIf
        
      Next ii
  EndSelect
Until Event = #PB_Event_CloseWindow

FreeMemory(*filemem)
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 195
; FirstLine = 174
; Folding = -
; EnableXP
; UseIcon = zx.ico
; Executable = zx2pic.exe
; CommandLine = "totalmur demo2.scr"